#В этом файле задаются кастомные функции базового порядка для дальнейшего использования

python early:
    health = 0
    hls = '♥' * health
    constructed_room = {}
    room_image = ['images/room01.jpg', 'images/room02.jpg', 'images/room03.jpg', 'images/room04.jpg', 'images/room05.jpg', 'images/room06.jpg', 'images/room07.jpg', 'images/room08.jpg']
    hallway_image = ['images/hall_deadend.jpg', 'images/hall_straight.jpg', 'images/hall_turn.jpg', 'images/hall_tcross.jpg', 'images/hall_cross.jpg']

    special_image = ['images/dark_room.jpg', 'images/crypt.jpg', 'images/webs.jpg', 'images/room04.jpg', 'images/room05.jpg', 'images/room06.jpg']
    special_encounter = ['darkness', 'sarcophagus', 'web', 'empty', 'empty', 'empty']

    #монстры
    monster = {
        'golem': {'str_DC': 4, 'con_DC': 6, 'luk_DC': 5, 'hp': 4, 'sword_hit': 'Меткий удар выбивает из голема какую-то важную шестеренку!', 'sword_miss': 'Бронированный автомат с легкостью выдерживает удар меча. Только исркы летят... Механический страж атакует в ответ!',  'magic_hit': 'Поток огня заставляет броню голема ракалиться докрасна. Может его вовсе заклинит?',  'magic_miss': 'Голем надежно защищен от магии. Он даже не обращает внимания на потоки огня которые обрушиваются на него и переходит в контратаку.',  'shot_hit': 'Прямо в сочленение брони! Арбалетный болт ударивший в правильное место может заклинить важный узел автоматона.',  'shot_miss': 'Арбалетный болт жалобно звякает о мощную броню голема и беспомощно отлетает к стене. Механизм переходит в контратаку! ', },
        'spider': {'str_DC': 5, 'con_DC': 4, 'luk_DC': 6, 'hp': 3, 'sword_hit': 'Меч входит в раздутое тело паука чуть ли не по рукоятку. Что, не любишь?!', 'sword_miss': 'Паук ловко уворачивается от удара и бросается в контратаку!',  'magic_hit': 'От обршившихся на него потоков пламени гигантский паук поджимает лапы и дергается. Огонь явно эффективен!',  'magic_miss': 'Каким-то чудом пауку удалось увернуться от огня. Пробежав по потолку он прыгает сверху!',  'shot_hit': 'Прямо в глаз! Конечно у паука их целых восем, но всё же это был отличный выстрел.',  'shot_miss': 'Арбалетный болт завяз в раздутом брюхе паука не причинив видимого вреда. Арахнид яростно контратакует!',},
        'cobra': {'str_DC': 6, 'con_DC': 5, 'luk_DC': 4, 'hp': 2, 'sword_hit': 'Кобра вертится из стороны в сторону, но несмтотря на это все же получает удар мечем по голове.', 'sword_miss': 'Кобра с легкостью уворачивается от удара и бросается в атаку. Она слишком быстра!',  'magic_hit': 'Кобре не удаётся увернуться от пламени. Она очаянно шипит и извивается на ракаленном полу.',  'magic_miss': 'Кобра вовремя уклоняется от направленных на неё потоков огня и мгновенно контраткует.',  'shot_hit': 'Арбалетный болт залетает змеюке прямо в широко распахнутую пасть. Отменный выстрел!',  'shot_miss': 'Двигаясь из стороны в сторону, кобре удается сбить прицел и увернуться от арбалетного болта. Она атакует в ответ!',},
        'ratling': {'str_DC': 5, 'con_DC': 4, 'luk_DC': 5, 'hp': 2, 'sword_hit': 'Меч с легкостью полосует крысолака. Кровь бьёт фонтаном!', 'sword_miss': 'Крысолак ловко обивает удар и бросается в контратаку!',  'magic_hit': 'Магический огонь охватывает крысолака целиком, наполняя комнату омерзительным запахом горелой шерсти.',  'magic_miss': 'Крысолак бесстрашно пробегает сквозь огонь и яростно атакует.',  'shot_hit': 'Меткий выстрел из арабалета заставляет крысолака на секунду остановиться и сбавить темп атаки.',  'shot_miss': 'Крысолак ловко уклоняется от выстрела и переходит в контратаку!',},
        'troll': {'str_DC': 6, 'con_DC': 4, 'luk_DC': 5, 'hp': 3, 'sword_hit': 'Каким то чудом острию меча удаётся пробить каменную шкуру тролля и тот отшатывается с удивлением глядя на текущую из его раны густую черную кровь.', 'sword_miss': 'Против прочной как камень шкуры меч и кинжал практически бесполезны. Атаку тролля не остановить!',  'magic_hit': 'Яркий магический огонь обжигает лицо тролля, заставляя того отшатнуться.',  'magic_miss': 'Тролль атакует проходя прямо сквозь пламя, словно бы даже не замечая его!',  'shot_hit': 'Хорошенько прицелившись можно повредить даже троллю! Тварь ревет от боли пытаясь выдрать из себя арбалетный болт.',  'shot_miss': 'Арбалетный болт отскочил от прочной шкуры тролля не причинив никакого вреда. Монстр нападает!',},        
        'mimic': {'str_DC': 5, 'con_DC': 5, 'luk_DC': 5, 'hp': 3, 'sword_hit': 'Странно видеть как при ударе меча от сундука вместо щепок летят брызки крови. Но по карайней мере эта тварь чувствует боль!', 'sword_miss': 'Меч отскакиевает от прочной древоподобной кожи мимимка, в то время как тот атакует щелкая зубастой пастью.',  'magic_hit': 'Поток вошлебного огня залетает прямо в зияющую крышку-пасть мимика, заставляя того корчиться и кашлять дымом.',  'magic_miss': 'Зубастый сундук захлопывает пасть чтобы переждать буйство колдовского пламени, а затем переходит в контратаку.',  'shot_hit': 'Арбалетный болт залетает мимику прямо в широко распахнутую пасть. Это было не слишком то сложно!',  'shot_miss': 'Арбалетный болт отскакивает от невероятно прочной шкуры живого сундука. Монстр нападает без тени сомнения.',},
        'skeleton': {'str_DC': 4, 'con_DC': 4, 'luk_DC': 6, 'hp': 3, 'sword_hit': 'Меч крушит кости скелета. Хотя нежить и не чувствует боли, рано или поздно он просто рассыпется на куски.', 'sword_miss': 'Каким бы ржавым ни был доспех этого скелета, он спасает своего носителя от меча. Мертвяк переходит в контратаку.',  'magic_hit': 'От жара колдовоского пламени старые кости скелета чернеют и лопаются! Долго он этого не выдержит.',  'magic_miss': 'Не чувствующий боли скелет идёт в атаку прямо сквозь стену колдовского пламени!',  'shot_hit': 'Попав скелету точно в сустав, тебе удается отстрелить ему одну из конечностей. Непростой выстрел!',  'shot_miss': 'Арбалетный болт беспомощно застревает в пустоте между ребрами скелета. Застрелить метвеца будет нелегкой задачей...',},
        'demon': {'str_DC': 6, 'con_DC': 6, 'luk_DC': 6, 'hp': 3, 'sword_hit': 'Вложив в удар всю свою силу тебе удаётся пробить чешую демона и ранить его!.', 'sword_miss': 'Оружие с беспомощным звоном отскакивает от прочной чешуи демона. Он атакует!',  'magic_hit': 'Магический огонь выходит настолько жарким, что обжигает даже закаленного в аду демона!',  'magic_miss': 'Демона закаленного в огненной геене трудно пронять вошлебным огнём. Он бросается в атаку!',  'shot_hit': 'На теле демона мало мест уязвимых для арбалета, но на этот раз стрела попадает ему прямо в глаз. Блестящий выстрел!',  'shot_miss': 'Арбалетная стрела отскакивает от прочной чешуи демона, не причинив тому ни малейшего вреда. Он замахивается когтями!',}
        }
        
    #более короткая запись для рандомайзера
    def rnd(x,y):
        return renpy.random.randint(x,y)
    
    #имитируем бросок кубика с х граней
    def d(x):
        return renpy.random.randint(1,x)
    
    #проверка атрибута
    def roll_atr(x):
        result = False
        dice = [0,0,0,0,0,0,0,0]
        n = x + 1
        for i in range(n):
            dice[i] = d(6)
        if max(dice) >= DC: result = True
        return result

    #Направление к комнате из которой герой только что пришел
    def turn_back():
        if direction == 0: op = 1
        if direction == 1: op = 0
        if direction == 3: op = 2
        if direction == 2: op = 3
        return op

    #функция для демонстрации произвольного задника
    def show_bg(at, st):
        return room[(ns,ow)]['image'], None

    #оставляем дверь открытой после прохода
    def door_stay_open():
        room[(ns,ow)]['exides'][direction] = 'clear'
        
    #создаём карту выходов
    def get_exid_map(x,y):
        exid = ['wall', 'wall', 'wall', 'wall']        
        for i in range(4):
            a = d(6)
            if a >= 4:
                exid[i] = 'clear'
            if a >= 6:
                exid[i] = 'door'
        if x == dungeon_size:
            exid[0] = 'wall'
        if x == 0:
            exid[1] = 'wall'
        if y == 0:
            exid[2] = 'wall'
        if y == dungeon_size:
            exid[3] = 'wall'            
        north_ns = ns + 1
        south_ns = ns - 1
        east_ow = ow - 1
        west_ow = ow + 1

        if (north_ns,ow) in room:
            exid[0] = room[(north_ns,ow)]['exides'][1]
        if (south_ns,ow) in room:
            exid[1] = room[(south_ns,ow)]['exides'][0]
        if (ns,east_ow) in room:
            exid[2] = room[(ns,east_ow)]['exides'][3]
        if (ns,west_ow) in room:
            exid[3] = room[(ns,west_ow)]['exides'][2]      
            
        room[(ns,ow)] = {'exides': [exid[0], exid[1], exid[2], exid[3]]}
        room[(ns,ow)]['random_encounter'] = 'empty'
        room[(ns,ow)]['consume_time'] = True
        room[(ns,ow)]['dungeon_exid'] = False

    #создаём комнату
    def get_room(x,y):
        room[(ns,ow)]['description'] = 'Это обычная комната, похожая на все остальные вокруг. '
        i = rnd(0,7)
        room[(ns,ow)]['image'] = room_image[i]
        room[(ns,ow)]['searchable'] = True
        n = len(random_encounter) - 1
        i = rnd(0,n)
        room[(ns,ow)]['random_encounter'] = random_encounter[i]

    #создаём особую комнату
    def get_special(x,y):
        i = rnd(0,2)
        room[(ns,ow)]['description'] = special_room_description[i]
        room[(ns,ow)]['image'] = special_image[i]
        room[(ns,ow)]['searchable'] = False
        room[(ns,ow)]['random_encounter'] = special_encounter[i]

    #создаём корридор
    def get_corridor (x,y):
        corridor_type_descriptions = [
            "Вы вошли в корридор который оканчивается тупком. Какая бессмысленная потеря времени... кто так строит?",
            "Просто прямой корридор. Здесь нет смысла заждерживаться.",
            "Изогнутый корридор заставляет вас свернуть в сторону. Здесь нет смысла заждерживаться.",
            "Корридор с Т-образной развилкой. Надо выбрать в какую сторону идти.",
            "Два корридора пересекаются под прямым углом. Иди на все четыре стороны..."
            ]
        room[(ns,ow)]['searchable'] = False
        room[(ns,ow)]['consume_time'] = False

        num_of_walls = room[(ns,ow)]['exides'].count('wall')
        strait_cooridor = False
        if room[(ns,ow)]['exides'][0] != 'wall' and room[(ns,ow)]['exides'][1] != 'wall':
            strait_cooridor = True
        if room[(ns,ow)]['exides'][2] != 'wall' and room[(ns,ow)]['exides'][3] != 'wall':
            strait_cooridor = True
            
        if num_of_walls >= 3:
            room[(ns,ow)]['description'] = corridor_type_descriptions[0]
            room[(ns,ow)]['image'] = hallway_image[0]
        elif num_of_walls == 0:
            room[(ns,ow)]['description'] = corridor_type_descriptions[4]  
            room[(ns,ow)]['image'] = hallway_image[4]
        elif num_of_walls == 1:
            room[(ns,ow)]['description'] = corridor_type_descriptions[3]
            room[(ns,ow)]['image'] = hallway_image[3]
        elif num_of_walls == 2 and strait_cooridor:
            room[(ns,ow)]['description'] = corridor_type_descriptions[1]  
            room[(ns,ow)]['image'] = hallway_image[1]
        else:
            room[(ns,ow)]['description'] = corridor_type_descriptions[2]     
            room[(ns,ow)]['image'] = hallway_image[2]
        


        