﻿init python:
    config.rollback_enabled = False    
    exit_type = ['clear', 'clear', 'clear', 'clear']
    bg_changer = 0
    direction = 1
    porticulus = False
    highscore = False
    outp = ' '
    
    if persistent.high_score <= 0: persistent.high_score = 0

    dungeon_size = 7 #размер подземелья по умолчанию
    
    #стартовые координаты по умолчанию
    ns = 0
    ow = 0
    
    #координаты комнаты с сокровищами
    central_room_ns = dungeon_size/2
    central_room_ow = dungeon_size/2    

    #библиотека сокровищ
    treasure = {
        'purse_of_gold': {'price': 100, 'quantity': 0, 'name': 'кошель с золотом'},
        'hungs': {'price': 1000, 'quantity': 0, 'name': 'алмазные подвески'},
        'incrusted_ring': {'price': 250, 'quantity': 0, 'name': 'инкрустированный перстень'},
        'pearl_necklace': {'price': 300, 'quantity': 0, 'name': 'жемчужное ожерелье'},        
        'saphire': {'price': 1000, 'quantity': 0, 'name': 'огромный сапфир'},
        'izumrud': {'price': 1500, 'quantity': 0, 'name': 'огромный изумруд'},
        'ruby': {'price': 2000, 'quantity': 0, 'name': 'огромный рубин'},       
        'diamond': {'price': 3000, 'quantity': 0, 'name': 'огромный алмаз'},
        'jems': {'price': 750, 'quantity': 0, 'name': 'шкатулка с самоцветами'},
        'crown': {'price': 2500, 'quantity': 0, 'name': 'золотая корона'},
        'scepter': {'price': 2000, 'quantity': 0, 'name': 'инкрустированный скипетр'},
        'statuette': {'price': 100, 'quantity': 0, 'name': 'ониксовая статуэтка'},
        'golden_chain': {'price': 50, 'quantity': 0, 'name': 'золотая цепочка'},
        'harp': {'price': 200, 'quantity': 0, 'name': 'серебрянная арфа'},
        'ring_wizard': {'price': 150, 'quantity': 0, 'name': 'кольцо чернокнижника'},
        'magic_wand': {'price': 100, 'quantity': 0, 'name': 'волшебная палочка'},
        'archmage_amulet': {'price': 250, 'quantity': 0, 'name': 'амулет архимага'},
        'ring_ram': {'price': 50, 'quantity': 0, 'name': 'кольцо барана'},
        'giant_belt': {'price': 100, 'quantity': 0, 'name': 'пояс великанской силы'},
        'mithril_chainmail': {'price': 1000, 'quantity': 0, 'name': 'мифрильная кольчуга'},
        'rabbit_paw': {'price': 1, 'quantity': 0, 'name': 'счастливая кроличья лапка'},
        'chameleon': {'price': 100, 'quantity': 0, 'name': 'плащ хамелеона'},
        'catstep_boots': {'price': 100, 'quantity': 0, 'name': 'кошачьи ботинки'}
        }
    
    treasure_list = ['purse_of_gold','hungs', 'incrusted_ring', 'pearl_necklace', 'saphire', 'izumrud', 'ruby', 'diamond', 'jems', 'crown', 'scepter', 'statuette', 'golden_chain', 'harp', 'ring_wizard',
        'magic_wand', 'archmage_amulet', 'giant_belt', 'mithril_chainmail', 'chameleon', 'catstep_boots', 'purse_of_gold', 'purse_of_gold', 'purse_of_gold', 'purse_of_gold']

    #описания особых комнат
    special_room_description = ['Похоже что эта комната заколдована так, что внутри ничего нельзя разглядеть. Даже факел не помогает. Бродить там наугад довольно опасно...',
        'Эта комната служит усыпальницей для какого-то древнего богача. Вполне возможно, что с ним вместе похоронены и его скоровища, однако тревожить старые кости - не лучшая идея.',
        'Вся комната плотно затянута подозрительно толстой паутиной. Чтобы прорваться насквозь прийдётся потратить немало сил и времени...',
        ]
    
    #список случайных комнат
    random_encounter = ['empty', 'empty', 'empty', 'empty', 'jug', 'jug', 'lb_beggar', 'lb_beggar', 'treashure_chest', 'treashure_chest', 'monster_golem', 'monster_ratling', 'monster_troll', 'corpse', 'corpse', 'torch_out', 'torch_out']
  
# Запускаем игру.
label start:
    $_game_menu_screen = 'preferences'
    define nvlator = Character(None, kind=nvl)
    define beggar = Character('Попрошайка', color="#c8c8ff")
    define jinn = Character('Освобожденный джинн', color="#c8c8ff")
    define demon = Character('Демон', color="#aa0000")
        
    #стартовые условия
    python:
        health = 5
        strength = 2
        concentration = 2
        luck = 2
        DC = 5
        remainig_time = 31
        gold = 0 
        times_looted = 0
        dragon_rises = False
        
        #заранее сгенеренные комнаты
        room = {(0,0): {'exides': ['clear', 'wall', 'wall', 'clear'], 'consume_time': True, 'dungeon_exid': True, 'searchable': False, 'random_encounter': 'empty', 'description': 'Выйти может лишь тот, кто обладает сокровищем!', 'image': 'images/dungeon_exid.jpg'},
        # (1,0): {'exides': ['door', 'clear', 'wall', 'door'], 'consume_time': True, 'dungeon_exid': False, 'searchable': True, 'random_encounter': 'jug', 'description': 'Это испытательный полигон для всяких фич.', 'image': 'images/room01.jpg'},
        (dungeon_size,0): {'exides': ['wall', 'clear', 'wall', 'clear'], 'consume_time': True, 'dungeon_exid': True, 'searchable': False, 'random_encounter': 'empty', 'description': 'Выйти может лишь тот, кто обладает сокровищем!', 'image': 'images/dungeon_exid.jpg'},
        (0,dungeon_size): {'exides': ['clear', 'wall', 'clear', 'wall'], 'consume_time': True, 'dungeon_exid': True, 'searchable': False, 'random_encounter': 'empty', 'description': 'Выти может лишь тот, кто обладает сокровищем!', 'image': 'images/dungeon_exid.jpg'},
        (dungeon_size,dungeon_size): {'exides': ['wall', 'clear', 'clear', 'wall'], 'consume_time': True, 'dungeon_exid': True, 'searchable': False, 'random_encounter': 'empty', 'description': 'Выйти может лишь тот, кто обладает сокровищем!', 'image': 'images/dungeon_exid.jpg'},
        (central_room_ns,central_room_ow): {'exides': ['clear', 'clear', 'clear', 'clear'], 'dungeon_exid': False, 'consume_time': True, 'random_encounter': 'dragon', 'searchable': False, 'description': 'Это центральная комната подземелья. Здсь должно быть сокровище, но всё уже украдено до нас.',  'image': 'images/hoard.jpg'}}


    #определяем изображения
    image bg = DynamicDisplayable(show_bg)
    image bg door = 'images/door.jpg'
    image bg porticulus = 'images/porticulus.jpg'
    image bg chest =  'images/chest.jpg'
    image bg web = 'images/webs.jpg'
    image bg skeleton =  'images/skeleton.jpg'
    image bg bats =  'images/bats.jpg'
    image bg blood =  'images/blood.jpg'
    image bg fire =  'images/fire.jpg'
    image bg gas =  'images/gas.jpg'
    image bg dark_room =  'images/dark_room.jpg'
    image bg shadow =  'images/shadow.png'
    image bg corpse =  'images/corpse.jpg'
    image bg beggar =  'images/beggar.jpg'
    image overlay =  'images/overlay.png'

    image monster skeleton = 'images/skeleton.png'
    image monster cobra = 'images/cobra.png'    
    image monster spider = 'images/spider.png'        
    image monster demon = 'images/demon.png'
    image monster mimic =  'images/chest_mimic.jpg'
    image monster golem = 'images/golem.png' 
    image monster troll = 'images/troll.png'
    image monster ratling = 'images/ratling.png'    
    image monster jinn = 'images/jinn.png'   

    image effect slash = 'images/slash.jpg'
    image effect fire = 'images/fire.jpg'
    image effect target = 'images/target.png'    
    image effect claw = 'images/claw.jpg'   
        
    # show image 'images/title.jpg'    

label lb_character_select:
    show bg 
    menu:
        'В зависимости от выбранного персонажа, его атрибуты силы, концентрации и удачи будут различаться. Красным подсвечены персонажи полагающиеся на силу, синим те у кого наибольшая концентрация, а желтым - удачиливые походимцы. Авантюрист песонаж сбалансированный.'
        'Авантюрист':
            $ strength = 2
            $ concentration = 2
            $ luck = 2          
            
        '{color=#a00}Грабитель{/color}':
            $ strength = 3
            $ concentration = 1
            $ luck = 2            
        
        '{color=#a00}Наемный убийца{/color}':
            $ strength = 3
            $ concentration = 2
            $ luck = 1       

        '{color=#00a}Преступный мозг{/color}':
            $ strength = 1
            $ concentration = 3
            $ luck = 2       

        '{color=#00a}Барыга{/color}':
            $ strength = 2
            $ concentration = 3
            $ luck = 1       
            
        '{color=#aa0}Мошенник{/color}':
            $ strength = 1
            $ concentration = 2
            $ luck = 3      
            
        '{color=#aa0}Контрабандист{/color}':
            $ strength = 2
            $ concentration = 1
            $ luck = 3      
            
label lb_corner_select:
    menu:
        'Выйти можно будет через любую дверь, но войти только в какую-то одну. Некоторые входы могут оказаться удобнее других, но заранее это узнать невозможно.'
        "Юго-восточный угол":
            $ ns = 0
            $ ow = 0

        "Юго-западный угол":
            $ ns = 0
            $ ow = dungeon_size

        "Северо-восточный угол":
            $ ns = dungeon_size
            $ ow = 0

        "Северо-западный угол":
            $ ns = dungeon_size
            $ ow = dungeon_size

    play music 'sound/bgm.ogg' loop
    
label lb_room_generator:   
    python:
        constructed_room = {}
        truechek = True
        hidden_door = False
        hidden_feature = False
        if (ns,ow) in room:
            truechek = False
        if truechek:
            get_exid_map(ns,ow)
            i = d(5)
            if i == 1:
                get_special(ns,ow)   
            elif i == 2:
                get_corridor(ns,ow)
            else:
                get_room(ns,ow)
                
        op_direction = turn_back()
        if porticulus: room[(ns,ow)]['exides'][op_direction] = 'porticulus' 
        for i in range(4):
            exit_type[i] = room[(ns,ow)]['exides'][i]
        
        if room[(ns,ow)]['consume_time']: remainig_time -= 1
        
        outp = ' '
        outp += room[(ns,ow)]['description']
        if porticulus: outp += ' За спиной раздаётся лязг и грохот. Это опустилась с потолка железная решетка, перекрывающая путь назад.'
    
    hide bg
    show bg with zoomin
    if porticulus: 
        play sound "sound/porticulus.ogg"          
        hide bg
        show bg with vpunch
    $ porticulus = False
    if room[(ns,ow)]['random_encounter'] != 'empty' and room[(ns,ow)]['random_encounter'] != 'dragon':
        jump expression room[(ns,ow)]['random_encounter'] 
    else:
        jump lb_interface_room
    
    return